diff -uwr sourceold/scripts/jfwdmg.cpp source/scripts/jfwdmg.cpp
--- sourceold/scripts/jfwdmg.cpp	2012-02-13 19:32:56.397859400 +0800
+++ source/scripts/jfwdmg.cpp	2012-04-25 11:41:04.667968700 +0800
@@ -15,6 +15,7 @@
 #include "engine.h"
 #include "jfwdmg.h"
 #include "BuildingGameObj.h"
+#include "VehicleGameObjDef.h"
 
 void JFW_Spawn_Object_Death::Killed(GameObject *obj,GameObject *killer)
 {
@@ -1049,7 +1050,7 @@
 
 void JFW_Kill_Message_Display::Custom(GameObject *obj,int type,int param,GameObject *sender)
 {
-	if (!param)
+	if (!param || !Commands->Find_Object(param) ||!sender)
 	{
 		return;
 	}
@@ -1060,7 +1061,7 @@
 			KilledID = 0;
 			KilledPlayerID = Get_Player_ID(sender);
 		}
-		else if (Is_Vehicle(sender) && (Get_Vehicle_Driver(sender)))
+		else if (sender->As_VehicleGameObj() && (Get_Vehicle_Driver(sender)))
 		{
 			KilledID = Commands->Get_Preset_ID(sender);
 			KilledPlayerID = Get_Player_ID(Get_Vehicle_Driver(sender));
@@ -1071,8 +1072,12 @@
 			KilledPlayerID = 0;
 		}
 		GameObject *Killer = Commands->Find_Object(param);
+		GameObject *explosion = GetExplosionObj();
+		if (!explosion || (explosion->As_VehicleGameObj() && Get_Vehicle_Mode(explosion) != VEHICLE_TYPE_TURRET))
+		{
 		Killer = Get_Vehicle_Return(Killer);
-		if (Is_Soldier(Killer))
+		}
+		if (Killer->As_SoldierGameObj())
 		{
 			KillerTeam = Get_Object_Type(Killer);
 			if (Commands->Is_A_Star(Killer))
@@ -1084,7 +1089,6 @@
 			{
 				KillerPlayerID = 0;
 			}
-			GameObject *explosion = GetExplosionObj();
 			if (explosion)
 			{
 				KillerID = Commands->Get_Preset_ID(explosion);
@@ -1094,10 +1098,9 @@
 				KillerID = Get_Definition_ID(Get_Current_Weapon(Killer));
 			}
 		}
-		else if (Is_Vehicle(Killer))
+		else if (Killer->As_VehicleGameObj())
 		{
 			KillerID = Commands->Get_Preset_ID(Killer);
-			GameObject *explosion = GetExplosionObj();
 			if (explosion)
 			{
 				KillerID = Commands->Get_Preset_ID(explosion);
@@ -1258,6 +1261,18 @@
 	return -1;
 }
 
+void JFW_Spawn_Object_Repair::Damaged(GameObject *obj,GameObject *damager,float amount)
+{
+	if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj) && amount)
+	{
+		Vector3 pos = Commands->Get_Position(obj);
+		float facing = Commands->Get_Facing(obj);
+		Commands->Destroy_Object(obj);
+		GameObject *o = Commands->Create_Object(Get_Parameter("Object"),pos);
+		Commands->Set_Facing(o,facing);
+	}
+}
+
 ScriptRegistrant<JFW_Invulnerable_On_Create> JFW_Invulnerable_On_Create_Registrant("JFW_Invulnerable_On_Create","Time:float,TimerNum:int,InvulnerableArmour:string,NormalArmour:string");
 ScriptRegistrant<JFW_Destroy_Self_Timer> JFW_Destroy_Self_Timer_Registrant("JFW_Destroy_Self_Timer","Time:float,TimerNum:int");
 ScriptRegistrant<JFW_Change_Model_Health> JFW_Change_Model_Health_Registrant("JFW_Change_Model_Health","Model:string,Health:float");
@@ -1312,3 +1327,4 @@
 ScriptRegistrant<JFW_C4_Explode> JFW_C4_Explode_Registrant("JFW_C4_Explode","Preset:string,Explosion:string");
 ScriptRegistrant<JFW_Timer_Destroy_Object> JFW_Timer_Destroy_Object_Registrant("JFW_Timer_Destroy_Object","Time:float,TimerNum:int,Amount:float,Warhead:string");
 ScriptRegistrant<JFW_Beacon_Building> JFW_Beacon_Building_Registrant("JFW_Beacon_Building","");
+ScriptRegistrant<JFW_Spawn_Object_Repair> JFW_Spawn_Object_Repair_Registrant("JFW_Spawn_Object_Repair","Object:string");
diff -uwr sourceold/scripts/jfwdmg.h source/scripts/jfwdmg.h
--- sourceold/scripts/jfwdmg.h	2011-10-14 22:27:32.069335900 +0800
+++ source/scripts/jfwdmg.h	2012-04-14 04:09:46.730468700 +0800
@@ -322,3 +322,7 @@
 	JFW_Beacon_Building() {pos = 0;}
 	~JFW_Beacon_Building();
 };
+
+class JFW_Spawn_Object_Repair : public ScriptImpClass {
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+};
diff -uwr sourceold/scripts/jfwgame.cpp source/scripts/jfwgame.cpp
--- sourceold/scripts/jfwgame.cpp	2012-02-13 19:32:56.856843700 +0800
+++ source/scripts/jfwgame.cpp	2012-04-24 21:25:30.892578100 +0800
@@ -492,7 +492,7 @@
 		object = Commands->Find_Object(ID);
 		Commands->Send_Custom_Event(obj,object,Collected_Message,Cash,0);
 		pos = Commands->Get_Position(object);
-		angle = Commands->Get_Facing(object);
+		angle = DEG_TO_RADF(Commands->Get_Facing(object));
 		pos.X+=Collected_Preset_Distance*(float)cos(angle);
 		pos.Y+=Collected_Preset_Distance*(float)sin(angle);
 		Commands->Create_Object(Collected_Preset,pos);
@@ -703,7 +703,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		enabled = false;
 		timertime = Get_Float_Parameter("Time");
@@ -883,7 +883,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		enabled = false;
 		if (Get_Int_Parameter("CinematicPowerOff") == 1)
@@ -1747,7 +1747,6 @@
 		if (HarvyID)
 		{
 			Commands->Apply_Damage(Commands->Find_Object(HarvyID),99999,"Explosive",0);
-			if (!Commands->Get_ID(Commands->Find_Object(HarvyID))) Commands->Destroy_Object(Commands->Find_Object(HarvyID));
 			Commands->Destroy_Object(obj);
 		}
 	}
@@ -2295,6 +2294,8 @@
 {
 	if (number == Get_Int_Parameter("TimerNum"))
 	{
+		if (Is_Base_Powered(Get_Object_Type(obj)))
+		{
 		Vector3 v = Commands->Get_Position(Find_Object_By_Preset(2,Get_Definition_Name(Get_Int_Parameter("CenterID"))));
 		if (Is_Unit_In_Range(Get_Parameter("Preset"),Get_Float_Parameter("Range"),v,PTTEAM(Get_Object_Type(obj)),false))
 		{
@@ -2316,6 +2317,7 @@
 				Enable_Base_Radar(Get_Object_Type(obj),true);
 			}
 		}
+		}
 		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
 	}
 }
@@ -2342,11 +2344,14 @@
 {
 	if (number == Get_Int_Parameter("TimerNum"))
 	{
+		if (Is_Base_Powered(Get_Object_Type(obj)))
+		{
 		Vector3 v = Commands->Get_Position(Find_Object_By_Preset(2,Get_Definition_Name(Get_Int_Parameter("CenterID"))));
 		if (Is_Unit_In_Range(Get_Parameter("Preset"),Get_Float_Parameter("Range"),v,PTTEAM(Get_Object_Type(obj)),false))
 		{
 			Create_2D_Sound_Team(Get_Parameter("Sound"),Get_Object_Type(obj));
 		}
+		}
 		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
 	}
 }
@@ -2700,6 +2705,31 @@
 	}
 }
 
+void JFW_Low_Power_Sound::Created(GameObject *obj)
+{
+	lowpower = false;
+	Commands->Start_Timer(obj,this,1.0,1);
+}
+
+void JFW_Low_Power_Sound::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		bool power = Is_Base_Powered(Commands->Get_Player_Type(obj));
+		if (power && lowpower)
+		{
+			lowpower = false;
+			Commands->Create_Sound(Get_Parameter("UpSound"),Commands->Get_Position(obj),obj);
+		}
+		if (!power && !lowpower)
+		{
+			lowpower = true;
+			Commands->Create_Sound(Get_Parameter("DownSound"),Commands->Get_Position(obj),obj);
+		}
+		Commands->Start_Timer(obj,this,1.0,1);
+	}
+}
+
 void JFW_Message_Send_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
 	int team = Get_Int_Parameter("Player_Type");
@@ -3176,6 +3206,7 @@
 ScriptRegistrant<JFW_Stealth_Generator_Vehicle_Deploy> JFW_Stealth_Generator_Vehicle_Deploy_Registrant("JFW_Stealth_Generator_Vehicle_Deploy","Stealth_Range=50:int,Stealth_Controller:string");
 ScriptRegistrant<JFW_Stealth_Generator_Ignored> JFW_Stealth_Generator_Ignored_Registrant("JFW_Stealth_Generator_Ignored","");
 ScriptRegistrant<JFW_Low_Power_Message> JFW_Low_Power_Message_Registrant("JFW_Low_Power_Message","Message:string");
+ScriptRegistrant<JFW_Low_Power_Sound> JFW_Low_Power_Sound_Registrant("JFW_Low_Power_Sound","DownSound:string,UpSound:string");
 ScriptRegistrant<JFW_Message_Send_Zone> JFW_Message_Send_Zone_Registrant("JFW_Message_Send_Zone","Player_Type:int,Message:string,Red:int,Blue:int,Green:int,Sound:string,Delete:int");
 ScriptRegistrant<JFW_Message_Send_Zone_Team> JFW_Message_Send_Zone_Team_Registrant("JFW_Message_Send_Zone_Team","Player_Type:int,Message:string,Red:int,Blue:int,Green:int,Sound:string,Delete:int");
 ScriptRegistrant<JFW_Message_Send_Zone_Player> JFW_Message_Send_Zone_Player_Registrant("JFW_Message_Send_Zone_Player","Player_Type:int,Message:string,Red:int,Blue:int,Green:int,Sound:string,Delete:int");
diff -uwr sourceold/scripts/jfwgame.h source/scripts/jfwgame.h
--- sourceold/scripts/jfwgame.h	2012-02-13 18:26:32.682039000 +0800
+++ source/scripts/jfwgame.h	2012-04-14 04:09:46.572265600 +0800
@@ -342,6 +342,12 @@
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+class JFW_Low_Power_Sound : public ScriptImpClass {
+	bool lowpower;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
 class JFW_Message_Send_Zone : public ScriptImpClass {
 	void Entered(GameObject *obj,GameObject *enterer);
 };
diff -uwr sourceold/scripts/jfwmisc.cpp source/scripts/jfwmisc.cpp
--- sourceold/scripts/jfwmisc.cpp	2012-02-13 19:32:56.703523400 +0800
+++ source/scripts/jfwmisc.cpp	2012-06-09 08:50:40.669921800 +0800
@@ -25,6 +25,7 @@
 #include "WeaponClass.h"
 #include "VehicleFactoryGameObj.h"
 #include "AirFactoryGameObj.h"
+#include "NavalFactoryGameObj.h"
 #include "PurchaseSettingsDefClass.h"
 
 void JFW_User_Settable_Parameters::Created(GameObject *obj)
@@ -914,7 +915,7 @@
 
 void JFW_Radar_Low_Power::Killed(GameObject *obj,GameObject *killer)
 {
-	GameObject *o = Find_Building(Get_Object_Type(obj),BuildingConstants::TYPE_COM_CENTER);
+	GameObject *o = Find_Building_By_Type(Get_Object_Type(obj),BuildingConstants::TYPE_COM_CENTER);
 	if (o && !Is_Building_Dead(o))
 	{
 		Enable_Base_Radar(Get_Object_Type(obj),false);
@@ -1247,6 +1248,41 @@
 	Destroy_Script();
 }
 
+void JFW_NavalFactory_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_NavalFactory_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_NavalFactoryGameObj())
+	{
+		if (type == Get_Int_Parameter("Disable_Custom"))
+		{
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_NavalFactoryGameObj()->Set_Disabled(true);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(true);
+			}
+			count++;
+		}
+		if (type == Get_Int_Parameter("Enable_Custom"))
+		{
+			count--;
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_NavalFactoryGameObj()->Set_Disabled(false);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(false);
+			}
+		}
+	}
+}
+
+void JFW_NavalFactory_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
 void JFW_Engineer_Hack::Created(GameObject *obj)
 {
 	Warhead = ArmorWarheadManager::Get_Warhead_Type(Get_Parameter("Hack_Warhead"));
@@ -1340,11 +1376,12 @@
 
 void JFW_EMP::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if (Warhead == Get_Damage_Warhead())
+	//if (Warhead == Get_Damage_Warhead())
 	{
 		VehicleGameObj *o = obj->As_VehicleGameObj();
 		if (o && o->Get_Is_Scripts_Visible() && !o->Is_Immovable())
 		{
+			Commands->Enable_Engine(obj,false);
 			o->Set_Immovable(true);
 			o->Set_Scripts_Can_Fire(false);
 			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
@@ -1360,6 +1397,7 @@
 	Commands->Set_Animation(obj,0,true,0,0,-1,false);
 	obj->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
 	o->Set_Immovable(false);
+	Commands->Enable_Engine(obj,true);
 	o->Set_Scripts_Can_Fire(true);
 }
 
@@ -1372,9 +1410,12 @@
 
 void JFW_EMP_Mine::Enemy_Seen(GameObject *obj, GameObject *enemy)
 {
+	if (enemy->As_VehicleGameObj())
+	{
 	Commands->Create_Explosion(Get_Parameter("Explosion"),Commands->Get_Position(obj),0);
 	Commands->Apply_Damage(obj,99999,"Death",0);
 }
+}
 
 void JFW_EMP_Mine::Destroyed(GameObject *obj)
 {
@@ -1401,7 +1442,14 @@
 			SoldierGameObj *s = sender->As_SoldierGameObj();
 			if (s)
 			{
-				GameObject *mine = Commands->Create_Object(Get_Parameter("Mine_Preset"),s->Get_Muzzle().Get_Translation());
+				Vector3 v = Commands->Get_Position(sender);
+				v.Z += Get_Float_Parameter("Mine_Z_Offset");
+				float len = Get_Float_Parameter("Mine_Distance");
+				float angle = DEG_TO_RADF(Commands->Get_Facing(sender));
+				v.X += cos(angle) * len;
+				v.Y += sin(angle) * len;
+				GameObject *mine = Commands->Create_Object(Get_Parameter("Mine_Preset"),v);
+				Commands->Set_Player_Type(mine,Commands->Get_Player_Type(sender));
 				PhysicalGameObj *p = mine->As_PhysicalGameObj();
 				p->Peek_Physical_Object()->Set_Collision_Group(TERRAIN_AND_BULLET_COLLISION_GROUP);
 			}
@@ -1532,6 +1580,10 @@
 	{
 		Destroy_Script();
 	}
+	if (min > max)
+	{
+		Destroy_Script();
+	}
 	float timer = Commands->Get_Random(min,max);
 	Commands->Start_Timer(obj,this,timer,1);
 }
@@ -1550,24 +1602,28 @@
 		{
 			Destroy_Script();
 		}
+		if (min > max)
+		{
+			Destroy_Script();
+		}
 		float timer = Commands->Get_Random(min,max);
 		Commands->Start_Timer(obj,this,timer,2);
 		Commands->Set_Lightning(Get_Float_Parameter("Lightning_Intensity"),Get_Float_Parameter("Lightning_Start_Distance"),Get_Float_Parameter("Lightning_End_Distance"),Get_Float_Parameter("Lightning_Heading"),Get_Float_Parameter("Lightning_Distribution"),0);
-		if (Find_Building(0,BuildingConstants::TYPE_COM_CENTER))
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_COM_CENTER))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
 		}
-		if (Find_Building(1,BuildingConstants::TYPE_COM_CENTER))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_COM_CENTER))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
 		}
-		if (Find_Building(0,BuildingConstants::TYPE_POWER_PLANT))
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_POWER_PLANT))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
 		}
-		if (Find_Building(1,BuildingConstants::TYPE_POWER_PLANT))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_POWER_PLANT))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
 		}
 		Timer_Expired(obj,3);
 		Create_2D_Sound_Team(Get_Parameter("Announcement_Sound_Nod"),0);
@@ -1582,21 +1638,21 @@
 	{
 		storm = false;
 		Commands->Set_Lightning(Get_Float_Parameter("Lightning_Off_Intensity"),Get_Float_Parameter("Lightning_Off_Start_Distance"),Get_Float_Parameter("Lightning_Off_End_Distance"),Get_Float_Parameter("Lightning_Off_Heading"),Get_Float_Parameter("Lightning_Off_Distribution"),0);
-		if (Find_Building(0,BuildingConstants::TYPE_COM_CENTER))
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_COM_CENTER))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
 		}
-		if (Find_Building(1,BuildingConstants::TYPE_COM_CENTER))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_COM_CENTER))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
 		}
-		if (Find_Building(0,BuildingConstants::TYPE_POWER_PLANT))
+		if (Find_Building_By_Type(0,BuildingConstants::TYPE_POWER_PLANT))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
 		}
-		if (Find_Building(1,BuildingConstants::TYPE_POWER_PLANT))
+		if (Find_Building_By_Type(1,BuildingConstants::TYPE_POWER_PLANT))
 		{
-			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
+			Commands->Send_Custom_Event(obj,Find_Building_By_Type(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
 		}
 		Create_2D_Sound_Team(Get_Parameter("End_Announcement_Sound_Nod"),0);
 		Create_2D_Sound_Team(Get_Parameter("End_Announcement_Sound_GDI"),1);
@@ -1615,6 +1671,10 @@
 		{
 			Destroy_Script();
 		}
+		if (min > max)
+		{
+			Destroy_Script();
+		}
 		float timer = Commands->Get_Random(min,max);
 		Commands->Start_Timer(obj,this,timer,1);
 	}
@@ -1628,6 +1688,181 @@
 	}
 }
 
+void JFW_Tech_Level_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("Message"))
+	{
+		Set_Tech_Level(Get_Int_Parameter("Tech_Level"));
+		Destroy_Script();
+	}
+}
+
+void JFW_Tech_Level_Startup::Created(GameObject *obj)
+{
+	Set_Tech_Level(Get_Int_Parameter("Tech_Level"));
+	Destroy_Script();
+}
+
+void JFW_Tech_Level_Timer::Created(GameObject *obj)
+{
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
+}
+void JFW_Tech_Level_Timer::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		Commands->Create_2D_Sound(Get_Parameter("Sound"));
+		Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),Get_Parameter("Display_Message"));
+		Set_Tech_Level(Get_Int_Parameter("Tech_Level"));
+		Destroy_Script();
+	}
+}
+
+void JFW_Change_Character_Created::Created(GameObject *obj)
+{
+	Change_Character(obj,Get_Parameter("Character"));
+	Destroy_Script();
+}
+
+void JFW_Spawn_Object_Created::Created(GameObject *obj)
+{
+	Commands->Create_Object(Get_Parameter("Object"),Commands->Get_Position(obj));
+	Destroy_Script();
+}
+
+void JFW_Change_Model_Created::Created(GameObject *obj)
+{
+	const char *model = 0;
+	do
+	{
+		int rand = Commands->Get_Random_Int(0,6);
+		if (rand == 1)
+		{
+			model = Get_Parameter("Model1");
+		}
+		if (rand == 2)
+		{
+			model = Get_Parameter("Model2");
+		}
+		if (rand == 3)
+		{
+			model = Get_Parameter("Model3");
+		}
+		if (rand == 4)
+		{
+			model = Get_Parameter("Model4");
+		}
+		if (rand == 5)
+		{
+			model = Get_Parameter("Model5");
+		}
+	} while (!model || !model[0]);
+	Commands->Set_Model(obj,model);
+	Destroy_Script();
+}
+
+extern REF_DECL2(NodHouseColor, Vector3);
+extern REF_DECL2(GDIHouseColor, Vector3);
+extern REF_DECL2(PublicMessageColor, Vector3);
+void JFW_Killed_String_Sound::Killed(GameObject *obj,GameObject *killer)
+{
+	if (Get_Object_Type(obj) == 0)
+	{
+		int red = (int)(NodHouseColor.X * 255);
+		int green = (int)(NodHouseColor.Y * 255);
+		int blue = (int)(NodHouseColor.Z * 255);
+		int stringgdi = Get_Int_Parameter("Nod_String_GDI");
+		if (stringgdi && Is_Valid_String_ID(stringgdi))
+		{
+			const char *str = Get_Translated_String(stringgdi);
+			Send_Message_Team(1,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringgdi);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+			}
+		}
+		int stringnod = Get_Int_Parameter("Nod_String_Nod");
+		if (stringnod && Is_Valid_String_ID(stringnod))
+		{
+			const char *str = Get_Translated_String(stringnod);
+			Send_Message_Team(0,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringnod);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+			}
+		}
+	}
+	else if (Get_Object_Type(obj) == 1)
+	{
+		int red = (int)(GDIHouseColor.X * 255);
+		int green = (int)(GDIHouseColor.Y * 255);
+		int blue = (int)(GDIHouseColor.Z * 255);
+		int stringgdi = Get_Int_Parameter("GDI_String_GDI");
+		if (stringgdi && Is_Valid_String_ID(stringgdi))
+		{
+			const char *str = Get_Translated_String(stringgdi);
+			Send_Message_Team(1,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringgdi);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+			}
+		}
+		int stringnod = Get_Int_Parameter("GDI_String_Nod");
+		if (stringnod && Is_Valid_String_ID(stringnod))
+		{
+			const char *str = Get_Translated_String(stringnod);
+			Send_Message_Team(0,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringnod);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+			}
+		}
+	}
+	else
+	{
+		int red = (int)(PublicMessageColor.X * 255);
+		int green = (int)(PublicMessageColor.Y * 255);
+		int blue = (int)(PublicMessageColor.Z * 255);
+		int stringgdi = Get_Int_Parameter("Neutral_String_GDI");
+		if (stringgdi && Is_Valid_String_ID(stringgdi))
+		{
+			const char *str = Get_Translated_String(stringgdi);
+			Send_Message_Team(1,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringgdi);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+			}
+		}
+		int stringnod = Get_Int_Parameter("Neutral_String_Nod");
+		if (stringnod && Is_Valid_String_ID(stringnod))
+		{
+			const char *str = Get_Translated_String(stringnod);
+			Send_Message_Team(0,red,green,blue,str);
+			delete[] str;
+			int soundId = Get_String_Sound_ID(stringnod);
+			if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+			{
+				Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+			}
+		}
+	}
+}
+
+
+ScriptRegistrant<JFW_Tech_Level_Timer> JFW_Tech_Level_Timer_Registrant("JFW_Tech_Level_Timer","Display_Message:string,Red:int,Blue:int,Green:int,Sound:string,Time:float,Tech_Level:int");
+ScriptRegistrant<JFW_Tech_Level_Startup> JFW_Tech_Level_Startup_Registrant("JFW_Tech_Level_Startup","Tech_Level:int");
+ScriptRegistrant<JFW_Tech_Level_Custom> JFW_Tech_Level_Custom_Registrant("JFW_Tech_Level_Custom","Message:int,Tech_Level:int");
+
 ScriptRegistrant<JFW_Stealthable_Object> JFW_Stealthable_Object_Registrant("JFW_Stealthable_Object","Message:int");
 ScriptRegistrant<JFW_Object_Counter> JFW_Object_Counter_Registrant("JFW_Object_Counter","Count:int,IncrementMessage:int,DecrementMessage:int");
 ScriptRegistrant<JFW_Fog_Create> JFW_Fog_Create_Registrant("JFW_Fog_Create","Fog_Enable:int,Fog_Start_Distance=0.000:float,Fog_End_Distance=0.000:float,Delay=0.000:float,OnCreate=0:int,OnDestroy=0:int");
@@ -1691,9 +1926,10 @@
 ScriptRegistrant<JFW_Refinery_Disable> JFW_Refinery_Disable_Registrant("JFW_Refinery_Disable","Disable_Custom:int,Enable_Custom:int");
 ScriptRegistrant<JFW_VehicleFactory_Disable> JFW_VehicleFactory_Disable_Registrant("JFW_VehicleFactory_Disable","Disable_Custom:int,Enable_Custom:int");
 ScriptRegistrant<JFW_AirFactory_Disable> JFW_AirFactory_Disable_Registrant("JFW_AirFactory_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_NavalFactory_Disable> JFW_NavalFactory_Disable_Registrant("JFW_NavalFactory_Disable","Disable_Custom:int,Enable_Custom:int");
 ScriptRegistrant<JFW_EMP> JFW_EMP_Registrant("JFW_EMP","Warhead:string,Time:fload,Animation:string");
 ScriptRegistrant<JFW_EMP_Mine> JFW_EMP_Mine_Registrant("JFW_EMP_Mine","Mine_Manager_ID:int,Explosion:string");
-ScriptRegistrant<JFW_EMP_Mine_Manager> JFW_EMP_Mine_Manager_Registrant("JFW_EMP_Mine_Manager","Mine_Preset:string,Mine_Limit:int,Mine_Reload:string");
+ScriptRegistrant<JFW_EMP_Mine_Manager> JFW_EMP_Mine_Manager_Registrant("JFW_EMP_Mine_Manager","Mine_Preset:string,Mine_Limit:int,Mine_Reload:string,Mine_Z_Offset:float,Mine_Distance:float");
 ScriptRegistrant<JFW_EMP_Mine_Layer> JFW_EMP_Mine_Layer_Registrant("JFW_EMP_Mine_Layer","Mine_Manager_ID:int,Warhead:string");
 ScriptRegistrant<JFW_Radar_Disable_Death> JFW_Radar_Disable_Death_Registrant("JFW_Radar_Disable_Death","");
 ScriptRegistrant<JFW_Cyborg_Reaper> JFW_Cyborg_Reaper_Registrant("JFW_Cyborg_Reaper","");
@@ -1702,3 +1938,7 @@
 ScriptRegistrant<JFW_Death_Send_Custom_Self> JFW_Death_Send_Custom_Self_Registrant("JFW_Death_Send_Custom_Self","Message:int");
 ScriptRegistrant<JFW_Hunter_Seeker> JFW_Hunter_Seeker_Registrant("JFW_Hunter_Seeker","Key:string,Explosion:string");
 ScriptRegistrant<JFW_Ion_Storm> JFW_Ion_Storm_Registrant("JFW_Ion_Storm","Min_Delay:float,Max_Delay:float,Min_Time:float,Max_Time:float,Disable_Custom:int,Enable_Custom:int,Announcement_Sound_Nod:string,Announcement_Sound_GDI:string,Announcement_String:string,Red:int,Green:int,Blue:int,Ion_Effect_Sound:string,Ion_Effect_Time:float,Lightning_Intensity:float,Lightning_Start_Distance:float,Lightning_End_Distance:float,Lightning_Heading:float,Lightning_Distribution:float,Lightning_Off_Intensity:float,Lightning_Off_Start_Distance:float,Lightning_Off_End_Distance:float,Lightning_Off_Heading:float,Lightning_Off_Distribution:float,End_Announcement_Sound_Nod:string,End_Announcement_Sound_GDI:string,End_Announcement_String:string");
+ScriptRegistrant<JFW_Change_Character_Created> JFW_Change_Character_Created_Registrant("JFW_Change_Character_Created","Character:string");
+ScriptRegistrant<JFW_Change_Model_Created> JFW_Change_Model_Created_Registrant("JFW_Change_Model_Created","Model1:string,Model2:string,Model3:string,Model4:string,Model5:string");
+ScriptRegistrant<JFW_Spawn_Object_Created> JFW_Spawn_Object_Created_Registrant("JFW_Spawn_Object_Created","Object:string");
+ScriptRegistrant<JFW_Killed_String_Sound> JFW_Killed_String_Sound_Registrant("JFW_Killed_String_Sound","GDI_String_GDI:int,Nod_String_GDI:int,Neutral_String_GDI:int,GDI_String_Nod:int,Nod_String_Nod:int,Neutral_String_Nod:int");
diff -uwr sourceold/scripts/jfwmisc.h source/scripts/jfwmisc.h
--- sourceold/scripts/jfwmisc.h	2011-10-22 19:58:24.060546800 +0800
+++ source/scripts/jfwmisc.h	2012-04-24 10:06:13.417968700 +0800
@@ -327,6 +327,13 @@
 	unsigned int count;
 };
 
+class JFW_NavalFactory_Disable : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	unsigned int count;
+};
+
 class JFW_Engineer_Hack : public ScriptImpClass {
 	unsigned int Warhead;
 	int IndcatorID;
@@ -405,3 +412,32 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 };
+
+class JFW_Tech_Level_Custom : public ScriptImpClass {
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
+class JFW_Tech_Level_Startup : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+class JFW_Tech_Level_Timer : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class JFW_Change_Character_Created : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+class JFW_Change_Model_Created : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+class JFW_Spawn_Object_Created : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+class JFW_Killed_String_Sound : public ScriptImpClass {
+	void Killed(GameObject *obj,GameObject *killer);
+};
